import 'package:fis_common/event/event_type.dart';

import 'output.dart';

abstract class ICalculator<TValue> {
  /// 输出结果
  OutputItem<TValue>? get output;

  /// 结果记录集合
  List<OutputItem<TValue>> get outputs;

  /// 计算
  void calculate();

  /// 结束一次测算
  void finishOnce();

  /// 输出结果变化事件
  late FEventHandler<OutputItem<TValue>?> outputChanged;
}
