import 'package:fis_common/event/event_type.dart';
import 'package:fis_measure/view/player/enums.dart';
import 'package:fis_measure/view/player/events.dart';
import 'package:vid/us/vid_us_image.dart';

/// 播放器控制器
abstract class IPlayerController {
  /// 状态
  VidPlayStatus get status;

  /// 当前帧的信息
  VidUsImage? get currentFrame;

  Future<void> load();

  /// 播放
  void play();

  /// 暂停
  void pause();

  /// 释放资源
  void dispose();

  /// 事件处理
  late FEventHandler<VidPlayerEvent> eventHandler;

  /// 当前帧信息返回的事件处理
  late FEventHandler<VidUsImage> currentFrameHandler;
}
