import 'package:fis_measure/interfaces/date_types/rect_region.dart';
import 'package:fis_measure/interfaces/enums/uint.dart';
import 'package:vid/us/vid_us_unit.dart';

import 'image_boundary.dart';

/// 逻辑坐标系
abstract class ILogicalCoordinate {
  /// 图像界限
  IImageBoundary get imageBoundary;

  /// 是否水平翻转
  bool get isFlipHorizontal;

  /// 是否垂直翻转
  bool get isFlipVertical;

  /// 所在区域(相对于整个图像)
  RectRegion get region;

  /// x轴单位
  VidUsUnit get xUnit;

  /// y轴单位
  VidUsUnit get yUnit;
}
