import 'package:fis_measure/interfaces/date_types/point.dart';
import 'package:fis_measure/interfaces/process/physical_coordinates/physical_coordinate.dart';
import 'package:vid/us/vid_us_physical_coordinate.dart';

class DopplerPhysicalCoordinate implements ITimeMotionPhysicalCoordiante {
  late final double _max;
  late final double _min;
  late final double _sweepSpeed;
  late final double _baseLine;

  DopplerPhysicalCoordinate(
    VidUsDopplerPhysicalCoordinate vidData,
  ) {
    _max = vidData.max;
    _min = vidData.min;
    _sweepSpeed = vidData.sweepSpeed;
    _baseLine = vidData.baseLine;
  }

  double get baseLine => _baseLine;

  @override
  double get max => _max;

  @override
  double get min => _min;

  @override
  double get sweepSpeed => _sweepSpeed;

  @override
  DPoint convert(DPoint point) {
    return point;
  }

  @override
  DPoint convertBack(DPoint point) {
    return point;
  }
}
