import 'package:fis_measure/interfaces/date_types/point.dart';
import 'package:fis_measure/interfaces/process/physical_coordinates/physical_coordinate.dart';
import 'package:vid/us/vid_us_physical_coordinate.dart';

class TissueTimeMotionPhysicalCoordinate
    implements ITimeMotionPhysicalCoordiante {
  late final double _max;
  late final double _min;
  late final double _sweepSpeed;
  late final double _depthStart;
  late final double _depthEnd;

  TissueTimeMotionPhysicalCoordinate(
    VidUsTissueTimeMotionPhysicalCoordinate vidData,
  ) {
    _max = vidData.max;
    _min = vidData.min;
    _sweepSpeed = vidData.sweepSpeed;
    _depthStart = vidData.depthStart;
    _depthEnd = vidData.depthEnd;
  }

  double get depthStart => _depthStart;

  double get depthEnd => _depthEnd;

  @override
  double get max => _max;

  @override
  double get min => _min;

  @override
  double get sweepSpeed => _sweepSpeed;

  @override
  DPoint convert(DPoint point) {
    return point;
  }

  @override
  DPoint convertBack(DPoint point) {
    return point;
  }
}
