import 'package:fis_measure/interfaces/date_types/rect_region.dart';
import 'package:fis_measure/process/visual/v2d_visual.dart';
import 'package:fis_vid/data_host/data_host.dart';
import 'package:fis_vid_ext/vid_value_element.dart';
import 'package:flutter/services.dart';
import 'package:vid/us/vid_us_image_data.dart';
import 'package:fis_vid_ext/vid_extended_data.dart';

class ThirdPartVidTest {
  void run() async {
    // final buffer = await rootBundle.load("assets/3rd.vid");
    // final vidData = VidUsImageData(buffer.buffer.asUint8List());
    final dataHost = VidDataHost(
        "http://cdn-bj.fis.plus/81FFF8E5E078473FA687FBE81C4869B1.vid");
    await dataHost.load();
    final vidData = await dataHost.getData();
    final extData = vidData!.getStructExtendedData();
    if (extData != null) {
      for (var key in extData.data.keys) {
        final val = extData.data[key] as VidValueElement;
        print('${key.group}-${key.element}: ${val.value}');
      }
    }
    final frame = vidData.getImage(0);
    for (var visual in frame.visuals) {
      final v = V2dVisual(visual, RectRegion.fill(0, 0, 1, 1));
      final a = v.visualAreas.first;
      print(a.displayRegion);
      print(a.mode.name);
      if (a.viewport != null) {
        print(a.viewport!.region);
      }
    }
  }
}
