import 'package:fis_measure/interfaces/process/workspace/application.dart';
import 'package:fis_measure/interfaces/process/workspace/point_info.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';

class MeasureTouchGesturePanel extends StatefulWidget {
  const MeasureTouchGesturePanel({Key? key}) : super(key: key);

  @override
  State<StatefulWidget> createState() => _MeasureTouchGesturePanelState();
}

class _MeasureTouchGesturePanelState extends State<MeasureTouchGesturePanel> {
  late final application = Get.find<IApplication>();

  @override
  void initState() {
    // TODO: from config
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(onTapDown: (details) {
      application.createPointInfo(
        details.localPosition,
        PointInfoType.touchDown,
      );
    }, onPanDown: (details) {
      application.createPointInfo(
        details.localPosition,
        PointInfoType.touchDown,
      );
    }, onPanUpdate: (details) {
      application.createPointInfo(
        details.localPosition,
        PointInfoType.touchMove,
      );
    }, onTapUp: (details) {
      application.createPointInfo(
        details.localPosition,
        PointInfoType.touchUp,
      );
    }, onPanEnd: (details) {
      application.createPointInfo(
        Offset.zero,
        PointInfoType.touchUp,
      );
    });
  }
}
