import 'dart:typed_data';

import 'package:flutter/material.dart';

class CaptureImage extends StatelessWidget {
  final Uint8List bytes;
  const CaptureImage({
    Key? key,
    required this.bytes,
  }) : super(key: key);
  @override
  Widget build(BuildContext context) {
    return SimpleDialog(
      children: [Image.memory(bytes)],
      titlePadding: EdgeInsets.zero,
      contentPadding: EdgeInsets.zero,
      backgroundColor: Colors.transparent,
      elevation: 4,
      shape: const RoundedRectangleBorder(
        borderRadius: BorderRadius.all(
          Radius.circular(
            4,
          ),
        ),
      ),
    );
  }
}
