import 'package:fis_i18n/i18n.dart';
import 'package:fis_jsonrpc/rpc.dart';
import 'package:fis_theme/theme.dart';
import 'package:fis_ui/index.dart';
import 'package:flutter/material.dart';

import 'package:get/get.dart';

///选中设置对话框
class HasSelectedSettingDialog extends FStatelessWidget {
  const HasSelectedSettingDialog({
    Key? key,
    required this.name,
  }) : super(key: key);
  final String name;

  @override
  FWidget build(BuildContext context) {
    return FSimpleDialog(
      title: FText(
        i18nBook.measure.selectedMeasureToolConfig.t,
        style: const TextStyle(
          color: Colors.white,
          fontSize: 18,
        ),
      ),
      isDefault: true,
      onOk: () {
        Get.back();
      },
      onCancel: () {
        Get.back();
      },
      children: [
        _DialogPage(name: name),
      ],
    );
  }
}

///对话框界面
class _DialogPage extends StatelessWidget {
  const _DialogPage({
    required this.name,
  });
  static BoxDecoration createBorder() {
    const border = BoxDecoration(
      border: Border(
        bottom: BorderSide(
          color: Color.fromRGBO(235, 235, 235, 1),
          width: 1,
        ),
      ),
    );
    return border;
  }

  final String name;
  // final controller = Get.put(MeasureConfigurationController());

  @override
  FWidget build(BuildContext context) {
    return FContainer(
      width: 700,
      height: 500,
      padding: const EdgeInsets.symmetric(horizontal: 15),
      child: FListView(
        shrinkWrap: true,
        children: [
          FColumn(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              FContainer(
                child: FText(i18nBook.measure.currentMeasureTool.t),
                margin: const EdgeInsets.symmetric(vertical: 10),
              ),
              FContainer(
                margin: const EdgeInsets.only(left: 15),
                child: FElevatedButton(
                  onPressed: () {},
                  style: ButtonStyle(
                    backgroundColor: MaterialStateProperty.all(
                      FTheme.ins.colorScheme.primary,
                    ),
                  ),
                  child: _buildMeasureName(name),
                ),
              ),
              const FSizedBox(
                height: 15,
              ),
              FContainer(
                decoration: _DialogPage.createBorder(),
              ),
              // controller.state.childItemMeta.multiMethodItems!.length
              if (2 != 0) ...[
                FContainer(
                  child: FText(i18nBook.measure.pleaseSelectMeasureMethod.t),
                  margin: const EdgeInsets.symmetric(vertical: 10),
                ),
                _HasSelectedModule(),
                const FSizedBox(
                  height: 15,
                ),
                FContainer(
                  decoration: _DialogPage.createBorder(),
                ),
                FContainer(
                  child: FText(
                      i18nBook.measure.pleaseSelectCalculateResultAndUnit.t),
                  margin: const EdgeInsets.symmetric(vertical: 10),
                ),
                FContainer(
                  margin: const EdgeInsets.only(left: 15),
                  child: FColumn(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: [
                      // FObx(() {
                      //   return
                      FContainer(
                        padding: const EdgeInsets.only(
                            left: 15, top: 15, bottom: 15),
                        child: FWrap(
                          spacing: 16.0, // 主轴(水平)方向间距
                          runSpacing: 8.0, // 纵轴（垂直）方向间距
                          direction: Axis.horizontal,
                          crossAlignment: WrapCrossAlignment.center,
                          alignment: WrapAlignment.start,
                          children: List<FWidget>.generate(
                            // controller.state.childItemMetaCalculator.length,
                            10,
                            (index) {
                              return FElevatedButton(
                                onPressed: () {},
                                style: ButtonStyle(
                                  backgroundColor: MaterialStateProperty.all(
                                    index == 0
                                        ? FTheme.ins.colorScheme.primary
                                        : Colors.white,
                                  ),
                                ),
                                child: _buildMeasureName(
                                    // controller.state
                                    //     .childItemMetaCalculator[index].name,
                                    ''),
                              );
                            },
                          ),
                        ),
                        //   );
                        // },
                      )
                    ],
                  ),
                ),
                const FSizedBox(
                  height: 15,
                ),
                FContainer(
                  decoration: _DialogPage.createBorder(),
                ),
              ],
            ],
          )
        ],
      ),
    );
  }

  /// 测量名字
  ///
  /// [name] 测量名
  FWidget _buildMeasureName(name) {
    return FContainer(
      width: 180,
      height: 60,
      child: FColumn(
        mainAxisAlignment: MainAxisAlignment.center,
        children: [
          FText(
            name,
            style: const TextStyle(
              color: Colors.white,
            ),
          ),
          FText(
            name,
            style: const TextStyle(
              color: Colors.white,
            ),
          ),
        ],
      ),
    );
  }
}

class _HasSelectedModule extends FStatefulWidget {
  @override
  FState<_HasSelectedModule> createState() => _HasSelectedModuleState();
}

class _HasSelectedModuleState extends FState<_HasSelectedModule> {
  /// 测量的控制器
  // final controller = Get.put(MeasureConfigurationController());

  /// 选中的方法
  late String selectedMeasureFun = '';
  List<ChildItemMetaDTO> multiMethodItems = [];

  @override
  void initState() {
    super.initState();
    // multiMethodItems = controller.state.childItemMeta.multiMethodItems!;
    selectedMeasureFun = multiMethodItems
        .firstWhere((element) => element.isWorking == true)
        .name!;
    print(selectedMeasureFun);
    // controller.state.childItemMetaCalculator = multiMethodItems
    //     .firstWhere((element) => element.isWorking == true)
    //     .calculator!
    //     .availableOutputs!;
  }

  @override
  FWidget build(BuildContext context) {
    return FListView(
      shrinkWrap: true,
      children: [
        FColumn(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            FContainer(
              padding: const EdgeInsets.only(left: 15, top: 15, bottom: 15),
              child: FWrap(
                spacing: 16.0, // 主轴(水平)方向间距
                runSpacing: 8.0, // 纵轴（垂直）方向间距
                direction: Axis.horizontal,
                crossAlignment: WrapCrossAlignment.center,
                alignment: WrapAlignment.start,
                children: List<FWidget>.generate(
                  multiMethodItems.length,
                  (index) {
                    return FElevatedButton(
                      onPressed: () {
                        setState(() {
                          // controller.state.childItemMetaCalculator =
                          //     multiMethodItems[index]
                          //         .calculator!
                          //         .availableOutputs!;
                          selectedMeasureFun = multiMethodItems[index].name!;
                        });
                      },
                      style: ButtonStyle(
                        backgroundColor: MaterialStateProperty.all(
                          multiMethodItems[index].name == selectedMeasureFun
                              ? FTheme.ins.colorScheme.primary
                              : Colors.white,
                        ),
                      ),
                      child: FContainer(
                        width: 180,
                        height: 60,
                        child: FCenter(
                          child: FText(
                            multiMethodItems[index].name!,
                            style: TextStyle(
                              color: multiMethodItems[index].name ==
                                      selectedMeasureFun
                                  ? Colors.white
                                  : Colors.black,
                            ),
                          ),
                        ),
                      ),
                    );
                  },
                ),
              ),
            ),
          ],
        ),
      ],
    );
  }
}
