import 'dart:convert';
import 'dart:math';

import 'package:fis_i18n/i18n.dart';
import 'package:fis_jsonrpc/services/aIDiagnosis.m.dart';
import 'package:fis_measure/interfaces/process/player/play_controller.dart';
import 'package:fis_measure/process/workspace/measure_data_controller.dart';
import 'package:fis_measure/view/paint/ai_patint_controller.dart';
import 'package:fis_measure/view/player/controller.dart';
import 'package:fis_measure/view/player/events.dart';
import 'package:fis_ui/index.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';

part 'progress_bar.dart';

class MobileVidControlBoard extends StatefulWidget {
  const MobileVidControlBoard(this.controller, {Key? key}) : super(key: key);

  final VidPlayerController controller;

  @override
  State<MobileVidControlBoard> createState() => _MobileVidControlBoardState();
}

class _MobileVidControlBoardState extends State<MobileVidControlBoard> {
  @override
  Widget build(BuildContext context) {
    return _SharedWidget(
      controller: widget.controller,
      child: Container(
        padding: const EdgeInsets.symmetric(horizontal: 20, vertical: 10),
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            _buildPlayStatusBar(),
          ],
        ),
      ),
    );
  }

  Widget _buildPlayStatusBar() {
    return Expanded(
      child: Row(
          mainAxisSize: MainAxisSize.min,
          crossAxisAlignment: CrossAxisAlignment.center,
          children: [
            const SizedBox(width: 30),
            Expanded(child: _ProgressBar()),
            const SizedBox(width: 30),
          ]),
    );
  }
}

class _SharedWidget extends InheritedWidget {
  const _SharedWidget({
    required Widget child,
    required this.controller,
  }) : super(child: child);

  final VidPlayerController controller;

  static _SharedWidget? of(BuildContext context) {
    try {
      final data = context.dependOnInheritedWidgetOfExactType<_SharedWidget>();
      return data;
    } catch (e) {
      //
    }
    return null;
  }

  @override
  bool updateShouldNotify(covariant InheritedWidget oldWidget) => false;
}
