import 'package:fis_measure/view/paint/date_structure.dart';
import 'package:fis_measure/view/player/enums.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';

class AiPatintState {
  final Rx<int> _frameIndex = Rx(0);
  final Rx<int> _aiResultIndex = Rx(0);

  final Rx<List<AIDiagnosisPerImageDTO>> _aiResult =
      Rx(<AIDiagnosisPerImageDTO>[]);

  final Rx<bool> _isShowAi = Rx(true);

  final Rx<VidPlayStatus> _vidStatus = Rx(VidPlayStatus.ready);

  /// 当前帧数
  set frameIndex(value) => _frameIndex.value = value;
  get frameIndex => _frameIndex.value;

  /// 当前ai帧数
  set aiResultIndex(int value) => _aiResultIndex.value = value;
  int get aiResultIndex => _aiResultIndex.value;

  /// ai结果集合
  set aiResult(List<AIDiagnosisPerImageDTO> value) => _aiResult(value);
  List<AIDiagnosisPerImageDTO> get aiResult => _aiResult.value;

  /// vid的播放状态
  set vidStatus(VidPlayStatus value) => _vidStatus(value);
  VidPlayStatus get vidStatus => _vidStatus.value;

  /// vid的播放状态
  set isShowAi(bool value) => _isShowAi(value);
  bool get isShowAi => _isShowAi.value;
}

class AiDotsResults {
  final List<Offset> aiResultsList;
  final int aiResultsIndex;

  /// ai的横纵坐标 四个点
  final Offset? p1;
  final Offset? p2;
  final Offset? p3;
  final Offset? p4;

  AiDotsResults({
    required this.aiResultsList,
    required this.aiResultsIndex,
    this.p1,
    this.p2,
    this.p3,
    this.p4,
  });
}
